//******************************************************************************
//  MSP430F4270 fE\tg
//
//  |[OSD16_Aϊʂ擾, `l5, oC|[ϊ
//@A-DϊʂEIA574ʂp\Rɏo
//******************************************************************************

#include "msp430x42x0.h"

void  t1ms(unsigned short dat);
void TX_DAT(unsigned int j);
void WR_8S(unsigned short addr);          // tbVEɏ
void ERASE_S1(unsigned short addr);       // ZOgPʂŃtbVE

static const unsigned short tb[11]={
       3, 4, 3, 4, 3, 4, 3, 3, 4, 3, 4    // EIA574̑M^C~O
};
const unsigned char rb[9]={
             5, 4, 3, 4, 3, 4, 3, 3, 4    // EIA574̎M^C~O
};


float sum;
unsigned short AD_DAT[32];                // ADp
unsigned char RX_DAT0;                    // EIA574Mpf[^Eobt@
int idx_rx;                               // EIA574MpCfbNX

void main(void)
{
  int i;
  unsigned short *addr0, j;

  WDTCTL = WDTPW + WDTHOLD;               // WDT̒~
  SCFQCTL = 94 - 1;                       // MCLK = 94 * ACLK * 2 = 6.16MHz, D = 2
  FLL_CTL0 = DCOPLUS + XCAP18PF;          // DCOPLUS = 1, eʕׂ18pF
  SCFI0 = FLLD_2 + FN_2;                  // D = 2, fDCOCLK =   2.2-17Mhz
  SCFI1 = 0x98;
//  _BIS_SR(SCG0);

  BTCTL = BT_ADLY_2000;                   // Basic Timer̃NbNACLK/256
  P5DIR |= 0x10;
  P1SEL |= 0x20;                          // TACLK
  P6SEL |= 0x03;
  t1ms(20);                               // 20ms҂. FLL+肷̂҂
  TACTL = TASSEL_1 + MC_2;                // NbNACLK, AӰ(TAR0FFFFh܂Ŷ)@c

  P1IES |= 0x02;                          // P1.0͗GbWŊ
  P1IE |= 0x02;                           // P1.0̊݉
  idx_rx = 0;                             // MCfbNXNA

  _BIS_SR(GIE);                           // ӊ݉

  SD16CTL = SD16VMIDON + SD16REFON + SD16SSEL_1 + SD16DIV_1 + SD16XDIV_1; //@ccc@
      // VMID I, 1.2V refI, SMCLK, /4, /16  fM = 6.16MHz / 4 / 16 = 96.256kHz
  t1ms(1);                                // 1ms҂FVref[q̃RfT[d҂@cccA
  SD16CTL &= ~SD16VMIDON;                 // VMID It@cccB

  SD16CTL = SD16VMIDON + SD16REFON + SD16SSEL_1 + SD16DIV_1 + SD16XDIV_1; //@ccc@
      // VMID I, 1.2V refI, SMCLK, /4, /16  fM = 6.16MHz / 2 / 3 = 1.027MHz
  t1ms(1);                                // 1ms҂FVref[q̃RfT[d҂@cccA
  SD16CTL &= ~SD16VMIDON;                 // VMID It@cccB

  SD16CCTL0 =  SD16BUF_0 + SD16DF + SD16OSR_128;  //@cccC
            // Int disable, oC|[2̕␔, OSR = 128
  SD16INCTL0 = SD16INTDLY_0 + SD16GAIN_1 + SD16INCH_0;  //@cccD
            // 4ڂ犄, PGA̗1, `l0(A0})

  do
  {
    for (j = 0x9000; j <= 0xE000; j = j + 4096)
    {
      while(RX_DAT0 != 55);
      RX_DAT0 = 0;
      WR_8S(j);                          // 1000h`f[^ށ@cccF

      addr0 = (unsigned short*) j;
      for (i = 0; i < 2048; i++)
      {
        TX_DAT(*(addr0 + i) >> 8);
        TX_DAT(*(addr0 + i));
      }
    }
    for (j = 0x9000; j < 0xF000; j = j + 512)
    {
      ERASE_S1(j);                       // 1000h-107fh܂ŏ@cccD
    }
  }while(1);                             // JԂ
}


//  tbVẼZOg SMCLK = 6.16 MHz
// ACCVIE = NMIIE = OFIE = 0 OƂ܂
void ERASE_S1(unsigned short addr)
{
  unsigned short *addr0, i;

  addr0 = (unsigned short *)addr;         // pAhXɐݒ@cccH

  WDTCTL = WDTPW + WDTHOLD;               // WDT̒~
  asm("DINT");                            // 荞݂fBXG[uɂ܂
  FCTL2 = FWKEY + FSSEL_2 + FN4;          // fFTG = SMCLK / 17 = 362kHz (257-476kHz)@cccI
  FCTL3 = FWKEY;                          // LOCK NA܂@cccJ
  FCTL1 = FWKEY + ERASE;                  // Cl[uɂ܂@cccK
  *addr0 = 0;                             // _~[݁AS1 ̏@cccL
  FCTL3 = FWKEY + LOCK;                   // ALOCK ̐ݒ@cccM
  asm("EINT"); 				  // 荞݂Cl[uɂ܂
}

// SD16_A̕ϊʂ4096oCgAtbVE֏ SMCLK = 6.16 MHz
void WR_8S(unsigned short addr)
{
  unsigned short *addr0, i;

  addr0 = (unsigned short *)addr;         // ݗpAhXɐݒ

  WDTCTL = WDTPW + WDTHOLD;               // WDT̒~
  asm("DINT");                            // 荞݂fBXG[uɂ܂
  FCTL2 = FWKEY + FSSEL_2 + FN4;          // fFTG = SMCLK / 17 = 362kHz (257-476kHz)@ccc@
  FCTL3 = FWKEY;                          // LOCK NA܂@cccA
  FCTL1 = FWKEY + WRT;                    // ݂Cl[uɂ܂@cccB

  SD16CCTL0 |= SD16SC;                    // ADϊJn@cccC
  for (i = 0; i < 2048; i++)
  {
    while ((SD16CCTL0 & SD16IFG) == 0);   // ϊI҂@cccD
    *(addr0 + i) = SD16MEM0;              // ϊʂFlash֏ށ@cccE
  }
  SD16CCTL0 &= ~SD16SC;                   // ADϊ~@cccF
  FCTL1 = FWKEY;                          // WRTNA@cccG
  FCTL3 = FWKEY + LOCK;                   // ALOCK ̐ݒ@cccH
  asm("EINT"); 				  // 荞݂Cl[uɂ܂@cccI
}

/***************************************
  1ms~datԑ҂ٰ
***************************************/
void t1ms(unsigned short dat)             // Basic Timer1ĝ5.4.2Ő
{
  unsigned short j;
  unsigned long i;

  i = 32.768 * dat - 22;                  // ACLK(32.768kHz)o߃JEgvZ
                                          // 22͎Ԓp(MCLK̒lŕς)
  do
  {
    j = BTCNT1;                           // j͉ʂ̃JE^l
    while(BTCNT1 == j);                   // BTCNT1JEgAbv܂ő҂
    i--;                                  // iPJEg
  }while (i != 0);                        // i=0(^CAbv)܂ŌJԂ
}

/******************************************************
// EIA574 Data transmit service routine
******************************************************/
void TX_DAT(unsigned int j)
{
  unsigned int i;                         // ϐ̐錾

  P5OUT |= 0x10;                          // TX = 0
  BTCNT1 = 0;                             // Timer_AJE^NA
  while (BTCNT1 < tb[0]);                 // 1҂
  BTCNT1 = 0;                             // Timer_AJE^NA
  P5OUT &= ~0x10;                         // TX = 1  X^[gErbg

  for (i = 0; i < 8; i++)                 // f[^̑M, D0
  {
    while (BTCNT1 < tb[i + 1]);           // 1҂
  BTCNT1 = 0;                             // Timer_AJE^NA
    if ((j & 0x1) == 0)
    {
      P5OUT &= ~0x10;                     // Mf[^0ȂTX = 1
    }
    else
    {
      P5OUT |= 0x10;                      // Mf[^1ȂTX = 0
    }
    j = j / 2;                            // Mf[^1rbgEVtg
  }
  while (BTCNT1 < tb[9]);                 // 1҂
  P5OUT |= 0x10;                          // TX = 0AXgbvErbg
  BTCNT1 = 0;                             // Timer_AJE^NA
  while (BTCNT1 < tb[10]);                // 1҂
}

/******************************************************
// PORT1 ݏ[`
// P1.1 = TxD
******************************************************/

#pragma vector = PORT1_VECTOR
__interrupt void PORT1(void)
{
  int i;

  if (P1IFG & 0x2)
  {
    RX_DAT0 = 0;
    for (i = 0; i < 8; i++)
    {
      RX_DAT0 = RX_DAT0 >> 1;
      BTCNT1 = 0;                         // BTCNT1NA
      while (BTCNT1 < rb[i]);             // 1҂
      if ((P1IN & 0x2) == 0x2)
      {
        RX_DAT0 = RX_DAT0 + 0x80;
      }
    }
    idx_rx++;
    BTCNT1 = 0;                           // BTCNT1NA
    while (BTCNT1 < rb[i]);               // 1҂
    P1IFG &= ~0x2;                        // P1.1̊݃tONA
  }
}
